/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);

//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
std::vector<VISA_opnd*> RTRWOperandsVec;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 142 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_VERSION = 13,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 14,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 15,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 16,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 17,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 18,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 19,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 20,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 21,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 22,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 23,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 24,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 25,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 26,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 27,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 28,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 29,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 31,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 32,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 33,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 34,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 35,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 36,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 37,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 38,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 39,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 40,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 41,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 42,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 43,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 51,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 52,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 53,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 54,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 55,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 56,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 57,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 58,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 59,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 60,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 61,                    /* RBRACE  */
  YYSYMBOL_DOT = 62,                       /* DOT  */
  YYSYMBOL_COMMA = 63,                     /* COMMA  */
  YYSYMBOL_SEMI = 64,                      /* SEMI  */
  YYSYMBOL_COLON = 65,                     /* COLON  */
  YYSYMBOL_SLASH = 66,                     /* SLASH  */
  YYSYMBOL_PERCENT = 67,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 68,                    /* EQUALS  */
  YYSYMBOL_PLUS = 69,                      /* PLUS  */
  YYSYMBOL_MINUS = 70,                     /* MINUS  */
  YYSYMBOL_TIMES = 71,                     /* TIMES  */
  YYSYMBOL_AMP = 72,                       /* AMP  */
  YYSYMBOL_CIRC = 73,                      /* CIRC  */
  YYSYMBOL_PIPE = 74,                      /* PIPE  */
  YYSYMBOL_TILDE = 75,                     /* TILDE  */
  YYSYMBOL_BANG = 76,                      /* BANG  */
  YYSYMBOL_QUESTION = 77,                  /* QUESTION  */
  YYSYMBOL_LEQ = 78,                       /* LEQ  */
  YYSYMBOL_GEQ = 79,                       /* GEQ  */
  YYSYMBOL_EQ = 80,                        /* EQ  */
  YYSYMBOL_NEQ = 81,                       /* NEQ  */
  YYSYMBOL_SHL = 82,                       /* SHL  */
  YYSYMBOL_SHRS = 83,                      /* SHRS  */
  YYSYMBOL_SHRZ = 84,                      /* SHRZ  */
  YYSYMBOL_LABEL = 85,                     /* LABEL  */
  YYSYMBOL_IDENT = 86,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 87,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 88,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 89,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 90,                   /* NEWLINE  */
  YYSYMBOL_UNIFORM = 91,                   /* UNIFORM  */
  YYSYMBOL_RTWRITE_OPTION = 92,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 93,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 94,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 95,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 96,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 97,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 98,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 99,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 100,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 101,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 102,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 103,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 104,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 105,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 106,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 107,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 108,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 109,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 110,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 111,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 112,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 113,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 114,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 115,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 116,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 117,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 118,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 119,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 120,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 121,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 122,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 123,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 124,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 125,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 126,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 127,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 128,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 129,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 130,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 131,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 132,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 133,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 134,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 135,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 136,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 137,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 138,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 139,                   /* IFCALL  */
  YYSYMBOL_FCALL = 140,                    /* FCALL  */
  YYSYMBOL_FADDR = 141,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 142,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 143,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 144,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 145,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 146,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 147,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 148,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 149,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 150,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 151,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 152,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 153,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 154,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 155,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 156,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 157,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 158,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 159,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 160,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 161,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 162,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 163,                   /* AVS_OP  */
  YYSYMBOL_BREAKPOINT_OP = 164,            /* BREAKPOINT_OP  */
  YYSYMBOL_CALL_OP = 165,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 166,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 167,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 168,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 169,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 170,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 171,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 172, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 173,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 174,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 175,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 176,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 177, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 178, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 179,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 180,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 181,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 182,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 183,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 184,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 185,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 186,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 187,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 188,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 189, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 190, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 191,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 192, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 193, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 194,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 195, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 196,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 197,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 198,                 /* $accept  */
  YYSYMBOL_Listing = 199,                  /* Listing  */
  YYSYMBOL_ListingHeader = 200,            /* ListingHeader  */
  YYSYMBOL_Statements = 201,               /* Statements  */
  YYSYMBOL_Newlines = 202,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 203,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 204,                /* Statement  */
  YYSYMBOL_Scope = 205,                    /* Scope  */
  YYSYMBOL_ScopeStart = 206,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 207,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 208,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 209,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 210,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 211,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 212,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 213,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 214,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 215,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 216,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 217,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 218,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 219,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 220,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 221,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 222,              /* InputOffset  */
  YYSYMBOL_InputSize = 223,                /* InputSize  */
  YYSYMBOL_DirectiveAttr = 224,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 225,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 226,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 227,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 228,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 229,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 230,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 231,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 232,              /* Instruction  */
  YYSYMBOL_Label = 233,                    /* Label  */
  YYSYMBOL_LogicInstruction = 234,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 235,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 236,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 237,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 238,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 239,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 240,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 241,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 242,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 243,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 244,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 245,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 246,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 247,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 248,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 249,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 250,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 251,           /* MovInstruction  */
  YYSYMBOL_BreakpointInstruction = 252,    /* BreakpointInstruction  */
  YYSYMBOL_MovsInstruction = 253,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 254,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 255,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 256,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 257,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 258,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 259, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 260, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 261, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 262,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 263,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 264,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 265,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 266,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 267,      /* Sample3dInstruction  */
  YYSYMBOL_Sample3DInstruction = 268,      /* Sample3DInstruction  */
  YYSYMBOL_CPSEnableOpt = 269,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 270, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 271,        /* Load3dInstruction  */
  YYSYMBOL_Load3DInstruction = 272,        /* Load3DInstruction  */
  YYSYMBOL_Gather43dInstruction = 273,     /* Gather43dInstruction  */
  YYSYMBOL_Gather43DInstruction = 274,     /* Gather43DInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 275,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 276,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 277,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 278,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 279,       /* RTWriteInstruction  */
  YYSYMBOL_RTWInstruction = 280,           /* RTWInstruction  */
  YYSYMBOL_RTWriteModeOpt = 281,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 282,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 283,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 284,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 285,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 286,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 287,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 288,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 289,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 290,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 291,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 292,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 293,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 294,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 295,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 296,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 297,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 298,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 299,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 300,                 /* LscFence  */
  YYSYMBOL_LscSfid = 301,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 302,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 303,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 304, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 305, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperand = 306, /* LscTypedAddrWithOffsetOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperandList = 307, /* LscTypedAddrWithOffsetOperandList  */
  YYSYMBOL_LscTypedAddrOperandWithOffsets = 308, /* LscTypedAddrOperandWithOffsets  */
  YYSYMBOL_LscAddrImmOffsetOpt = 309,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 310,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 311,          /* LscAddrModelOpt  */
  YYSYMBOL_LscAddrModelStateful = 312,     /* LscAddrModelStateful  */
  YYSYMBOL_LscVectorOpRegOrImm32 = 313,    /* LscVectorOpRegOrImm32  */
  YYSYMBOL_LscVectorOpImm32 = 314,         /* LscVectorOpImm32  */
  YYSYMBOL_LscVectorOpReg = 315,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 316,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 317,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 318,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 319,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 320,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 321,        /* BranchInstruction  */
  YYSYMBOL_FILE = 322,                     /* FILE  */
  YYSYMBOL_LOC = 323,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 324,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 325,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 326,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 327,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 328,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 329,            /* OwordModifier  */
  YYSYMBOL_Predicate = 330,                /* Predicate  */
  YYSYMBOL_PredSign = 331,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 332,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 333,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 334,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 335,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 336,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 337,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 338,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 339, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 340,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 341,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 342,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 343,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 344,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 345,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 346,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 347,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 348,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 349,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 350,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 351,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 352,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 353,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 354,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 355,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 356,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 357,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 358,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 359,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 360,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 361,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 362,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 363,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 364,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 365,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 366,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 367,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 368,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 369,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 370,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 371,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 372,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 373,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 374,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 375,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 376,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 377,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 378,              /* ExecSizeInt  */
  YYSYMBOL_Var = 379,                      /* Var  */
  YYSYMBOL_VarNonNull = 380,               /* VarNonNull  */
  YYSYMBOL_IntExp = 381,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 382,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 383,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 384,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 385,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 386,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 387,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 388,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 389,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 390,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 391,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 392,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 393,               /* IntExpPrim  */
  YYSYMBOL_DataType = 394,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 395       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2985

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  198
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  198
/* YYNRULES -- Number of rules.  */
#define YYNRULES  447
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1131

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   452


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   653,   653,   658,   660,   660,   662,   662,   663,   663,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     680,   681,   682,   686,   690,   693,   693,   700,   708,   716,
     723,   724,   725,   726,   727,   728,   730,   737,   745,   753,
     760,   764,   764,   767,   775,   780,   792,   799,   807,   807,
     808,   814,   818,   822,   826,   831,   837,   837,   839,   843,
     849,   857,   863,   868,   873,   879,   883,   887,   893,   898,
     904,   908,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,   935,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
     966,   967,   968,   970,   974,   980,   985,   991,   998,  1004,
    1011,  1018,  1025,  1032,  1044,  1051,  1060,  1070,  1076,  1083,
    1089,  1098,  1108,  1115,  1122,  1130,  1139,  1146,  1153,  1159,
    1165,  1171,  1177,  1195,  1202,  1212,  1220,  1227,  1234,  1243,
    1252,  1261,  1269,  1272,  1275,  1278,  1281,  1286,  1293,  1301,
    1302,  1308,  1321,  1329,  1336,  1339,  1354,  1354,  1356,  1356,
    1358,  1361,  1374,  1377,  1390,  1390,  1393,  1401,  1409,  1412,
    1416,  1421,  1424,  1436,  1436,  1440,  1448,  1460,  1476,  1482,
    1495,  1503,  1510,  1518,  1524,  1530,  1536,  1542,  1549,  1550,
    1559,  1560,  1561,  1563,  1564,  1565,  1567,  1570,  1571,  1572,
    1573,  1575,  1602,  1634,  1664,  1692,  1718,  1746,  1775,  1809,
    1853,  1898,  1934,  1973,  1978,  1978,  1981,  1982,  1983,  1987,
    1996,  2002,  2011,  2031,  2050,  2054,  2057,  2062,  2065,  2070,
    2076,  2084,  2097,  2098,  2099,  2104,  2105,  2108,  2109,  2110,
    2111,  2115,  2118,  2121,  2124,  2127,  2130,  2135,  2135,  2139,
    2149,  2157,  2165,  2179,  2183,  2189,  2194,  2197,  2201,  2204,
    2209,  2212,  2215,  2222,  2226,  2230,  2234,  2240,  2245,  2252,
    2259,  2264,  2269,  2275,  2282,  2289,  2295,  2301,  2309,  2317,
    2325,  2335,  2340,  2345,  2350,  2355,  2360,  2365,  2370,  2375,
    2375,  2381,  2386,  2391,  2391,  2393,  2393,  2396,  2396,  2399,
    2400,  2401,  2402,  2404,  2404,  2409,  2410,  2412,  2413,  2417,
    2418,  2421,  2422,  2425,  2426,  2427,  2430,  2431,  2434,  2435,
    2436,  2439,  2440,  2443,  2444,  2446,  2448,  2458,  2465,  2473,
    2481,  2500,  2512,  2519,  2531,  2536,  2543,  2548,  2556,  2564,
    2570,  2575,  2597,  2601,  2607,  2617,  2625,  2632,  2642,  2648,
    2655,  2659,  2664,  2668,  2674,  2675,  2682,  2690,  2691,  2697,
    2707,  2715,  2724,  2742,  2756,  2759,  2770,  2781,  2786,  2791,
    2799,  2808,  2820,  2834,  2836,  2847,  2859,  2865,  2873,  2882,
    2882,  2883,  2883,  2886,  2888,  2889,  2891,  2892,  2894,  2895,
    2897,  2898,  2900,  2901,  2902,  2904,  2905,  2906,  2907,  2908,
    2927,  2930,  2931,  2932,  2933,  2935,  2936,  2937,  2939,  2940,
    2945,  2950,  2952,  2953,  2954,  2955,  2959,  2960,  2962,  2966,
    2970,  2976,  2985,  2986,  2987,  2988,  2990,  2991
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ", "ATTR_EQ", "OFFSET_EQ",
  "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ", "V_TYPE_EQ_G", "V_TYPE_EQ_P",
  "V_TYPE_EQ_A", "V_TYPE_EQ_S", "V_TYPE_EQ_T", "CPS",
  "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK", "RAW_SEND_STRING",
  "RAW_SENDC_STRING", "RAW_SENDS_STRING", "RAW_SENDS_EOT_STRING",
  "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING", "SAT", "SRCMOD_ABS",
  "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP", "DPAS_OP",
  "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL", "NBARRIER_WAIT",
  "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "VTYPE",
  "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK",
  "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON",
  "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES", "AMP", "CIRC",
  "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ", "NEQ", "SHL",
  "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL", "BUILTIN",
  "STRING_LIT", "NEWLINE", "UNIFORM", "RTWRITE_OPTION", "MEDIA_MODE",
  "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT", "EXECMODE",
  "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "BREAKPOINT_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveAttr", "DirectiveFunc", "AlignAttrOpt", "Align",
  "AliasAttrOpt", "OneAttr", "AttrOpt", "GenAttrOpt", "Instruction",
  "Label", "LogicInstruction", "UnaryLogicInstruction",
  "MathInstruction_2OPND", "MathInstruction_3OPND",
  "ArithInstruction_2OPND", "ArithInstruction_3OPND",
  "ArithInstruction_4OPND", "DpasInstruction", "BfnInstruction",
  "QwScatterInstruction", "FCvtInstruction", "AntiTrigInstruction",
  "AddrAddInstruction", "SetpInstruction", "SelInstruction",
  "MinInstruction", "MaxInstruction", "MovInstruction",
  "BreakpointInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "Sample3DInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Load3DInstruction", "Gather43dInstruction",
  "Gather43DInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperands", "RTWriteInstruction",
  "RTWInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrWithOffsetOperand",
  "LscTypedAddrWithOffsetOperandList", "LscTypedAddrOperandWithOffsets",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscAddrModelStateful", "LscVectorOpRegOrImm32", "LscVectorOpImm32",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "SwitchLabels", "BranchInstruction", "FILE",
  "LOC", "RawSendInstruction", "LifetimeStartInst", "LifetimeEndInst",
  "RawSendsInstruction", "NullaryInstruction", "OwordModifier",
  "Predicate", "PredSign", "PredCtrlOpt", "SatModOpt", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A_AO",
  "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO", "VecSrcOperand_G_A",
  "VecSrcOperand_G_A_AO", "VecSrcOperand_G", "VecSrcOpndSimple",
  "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand", "DstStateOperand",
  "RawOperand", "RawOperandNonNull", "RawOperandOffsetSuffix",
  "RawOperandArray", "DstAddrOperand", "DstGeneralOperand",
  "DstIndirectOperand", "SrcAddrOfOperand", "AddrOfVar", "SrcAddrOperand",
  "SrcGeneralOperand", "SrcImmOperand", "FloatLit", "DoubleFloatLit",
  "SrcIndirectOperand", "DstRegion", "SrcRegionDirect",
  "SrcRegionIndirect", "IndirectVarAccess", "TwoDimOffset", "PredVar",
  "AddrVarAccess", "AddrVarAccessWithWidth", "SIMDMode", "ElemNum",
  "ExecSize", "ExecSizeInt", "Var", "VarNonNull", "IntExp", "IntExpCond",
  "IntExpAND", "IntExpXOR", "IntExpOR", "IntExpCmp", "IntExpRel",
  "IntExpNRA", "IntExpShift", "IntExpAdd", "IntExpMul", "IntExpUnr",
  "IntExpPrim", "DataType", "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1004)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-437)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -19, -1004,    45,     1,    91, -1004, -1004,   -43,   -19, -1004,
      77,  2788,    94,    61,   -26,   110,   -26,   147,   230,   -26,
     256,    92,    49,    49,   314, -1004, -1004,    92,   346,    23,
     318,   369,   404, -1004, -1004, -1004,   373,   377,   416,   163,
     417,   -26,    92,    92,    92,   389,   310, -1004,  1077,   381,
     382, -1004, -1004,   387,   396,   398,   407,   401, -1004,    28,
     462,   -19, -1004, -1004,  2457, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,  1651, -1004,   345,
   -1004, -1004, -1004, -1004, -1004,   481,   481, -1004,   432,   -37,
     273, -1004, -1004, -1004, -1004,   163,     4,    58,     4,     4,
   -1004, -1004, -1004, -1004, -1004,   142,   338,   -10, -1004,    15,
      49, -1004, -1004, -1004, -1004, -1004, -1004,   448,   444, -1004,
      71, -1004, -1004, -1004,   163,   163, -1004,    92,    92,    92,
      49, -1004,    92,   444,   335,    92,   447,   410,   340,   163,
     273,    49,   163,    15,    49,   163,   163, -1004, -1004,   163,
   -1004, -1004, -1004, -1004, -1004,    92,    92, -1004, -1004,   163,
   -1004, -1004,   323, -1004,    92,  2260, -1004, -1004,  2628,    92,
      92,   404,   404,   404,   404,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,    92,
     449,   418,   419,   508,   422,   456,   427,   519,   521,    92,
      92,   -16,    92,   462,   498,   498,   498,   435,    92,    92,
     466,    85,   343,   347,   137,   348,   349,   168,   344,   485,
     518,   520,   523,   524,     4,   164,   517,   166, -1004,   480,
     486,   491,   273, -1004,   492,    36,   497,     4, -1004, -1004,
     484, -1004,    46,   488,   483, -1004,   270,    30, -1004,   162,
      29, -1004,   174, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004,   472, -1004,   448,   444, -1004,     4, -1004,
     208,     4,   509, -1004, -1004, -1004,   400, -1004,   399, -1004,
   -1004,   506,    15,    49,    49,   273,   163,   163, -1004,   318,
     402,   163,   163,   502,   273,   273,   504,   273, -1004, -1004,
   -1004,   515,   129,   514,   163,    49, -1004,   144,    49,   163,
     163,   163,   388,   163, -1004, -1004,   -19, -1004,   409,   413,
     404,   404,   404,   404,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    15,   423,
      92,    92,   525,    92,   424,    92,   526,   526,   -26, -1004,
      92,    49,   499,    92, -1004,   560,   507,   510, -1004,    92,
     428,   -26,   434,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   353,   583,     4,     4,     4,     4, -1004,
     561,     4,   606, -1004, -1004, -1004, -1004, -1004,   454,   455,
     273,   -21, -1004, -1004,     4,     4, -1004,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,   566,   208,   509,   332,   159,
   -1004, -1004, -1004, -1004, -1004,   565,     4, -1004, -1004,   570,
     163, -1004,  1008, -1004, -1004,   575, -1004, -1004,   573,     4,
      49,    49,   129,   273,   273, -1004,    49,  1227,   163,   574,
     353,   163,   463,   273,   273,    49,   273,     4,   208, -1004,
     515,    -4, -1004,   579, -1004, -1004,   580,     4, -1004,   273,
     273,    49, -1004,  1077,   578,   474,   475,   404,   404,   404,
     404,    15,    15,    15,    15,    15,    15,    15,    15,    15,
      15,    15,    15,    15,    15,    15,   585,    49,    49,   476,
      92,   163,    92,   163,   479,    92,    92, -1004,    49,   482,
     487,    15, -1004,   622,    92,    92,   163,   489, -1004,    92,
     478,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,   491,   279, -1004, -1004,   492,     4,   606,   606,   631,
     631,   567, -1004, -1004,   595, -1004,   163,     4, -1004,   599,
     598,   488,   114,   483, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004,    29,    29,   333,   333,   333, -1004, -1004, -1004, -1004,
   -1004, -1004,   490,     4,     4,     4,   596, -1004, -1004, -1004,
   -1004, -1004, -1004,     4,     4,   602,    49,    49, -1004, -1004,
     273,   271,    49,    49,    49, -1004,   273,   273,    49,   603,
     273, -1004,   601,   273,   611, -1004, -1004,    -4,    -4,   607,
       4,     4,   176,   273, -1004,    49, -1004, -1004,   500,   501,
     404,   404,    92,    92,    49,    49,   163,    49,   163,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
      49,   505,   273,   273, -1004,   273,   273,   163,    49, -1004,
     163,   163,   522,   528,   529,  1069,  1069,   209, -1004,   572,
      49,    49, -1004,   273,   163, -1004,   353,   353,   353,   353,
     267,   279,   267,   511,   353,   353,   613,   618,   634,   638,
     653, -1004, -1004,   608,   606,   606,   621, -1004,   120, -1004,
   -1004,   444,   636, -1004, -1004,     4,   645,   637,   642,   646,
     244,   650, -1004, -1004, -1004,    49,   273,   273,   273,   273,
      49, -1004,   273,    49, -1004, -1004, -1004, -1004, -1004,   647,
     246, -1004, -1004,    49,  1077,  1077,    92,    92,  1077,  1077,
      49, -1004, -1004,    49,   163,    49,    49,    49,    49,    49,
   -1004, -1004,    49, -1004,    49,    49,    49,    92,   273,   273,
     273,   273,    49,   273,   273,   273,   535, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004,   573,    92,   163,   163,
    1852,   273,   273,   267,   229,   279,   267,   511,   527, -1004,
   -1004,   353,   652, -1004,   353,   655, -1004,   353,   657,   659,
     353,   267,   279,   -18,   -18,   -18,   197,    35,   701, -1004,
   -1004, -1004, -1004,   282, -1004,   567, -1004, -1004, -1004, -1004,
       4, -1004, -1004,     4,   273, -1004,   273,   273,   273,    49,
     273,   660, -1004,    49,   273,   273,  1077,  1077,  1077,  1077,
      49, -1004, -1004,    49,    49, -1004, -1004, -1004, -1004, -1004,
      49, -1004,   273, -1004, -1004,   273,   273,   273,   273,   273,
     273, -1004,    49,   273,   163, -1004, -1004,   273,   273, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,    39, -1004,   197,
   -1004,    39,   163, -1004,   353,   353,   249, -1004, -1004,   263,
   -1004,   280,   285,   662, -1004,   492, -1004, -1004, -1004, -1004,
     663,   606, -1004, -1004, -1004,   666,   669, -1004, -1004, -1004,
     273,    49,   273, -1004,    49,   273,   273,  1077,  1077,   273,
     273, -1004, -1004,    49, -1004,   273,   273,   273,   273, -1004,
     273,   273,   163, -1004,   273,   273, -1004,   197,   654,   661,
     672,   339,   197,   667,   353,   353, -1004,     4,     4,   562,
   -1004,     4, -1004,     4, -1004,    43, -1004, -1004, -1004, -1004,
     273, -1004,    49, -1004, -1004,   273,   273,   273,   273, -1004,
   -1004, -1004,   273, -1004,   273,   273,   163,   273, -1004, -1004,
     364, -1004,   197,   554,     4,     4,   364,   -18, -1004, -1004,
     673,   670, -1004,   675,   676, -1004,   674, -1004,    49,   273,
     273,   273,   273, -1004, -1004,   273,   273, -1004,   273,     4,
       4,   680,   678, -1004,    29,    29,    64,   679, -1004,     4,
   -1004, -1004,     4,   640,   273,   273, -1004, -1004,   273, -1004,
     333,    29,   568,   197,   -18,   -18,   688,   698,    49, -1004,
   -1004,   273,   273, -1004,   693,   706,   694, -1004, -1004,   668,
   -1004,   197,   591,   -18,    49, -1004, -1004,   704,   273,   -18,
   -1004,   705,   364,     4,   709,   713,   163, -1004,   364,   718,
   -1004
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   311,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   313,    23,   123,     0,   323,     0,
     309,     0,     0,   162,   163,   164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   301,     0,   304,
     306,   308,   303,     0,     0,     0,     0,     0,   149,     0,
     317,     8,     5,    19,     0,    11,    12,    10,    35,    30,
      31,    32,    33,    34,    14,    13,    16,    15,    17,    18,
      72,    74,    75,    76,    77,    78,    79,   117,   118,   119,
     121,    80,    81,   102,    99,   100,   101,    98,   122,    97,
      82,    83,    85,    86,    88,    87,    89,    91,    92,    94,
      93,   107,   174,   108,   180,   109,   182,   110,   111,   112,
     191,   113,    96,    95,    84,    73,   120,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,    90,
     103,   104,   105,   114,   115,   106,   116,     0,    29,     0,
      25,    26,    55,    36,    28,    48,    48,    27,    53,     0,
       0,   320,   319,   321,   322,     0,     0,     0,     0,     0,
     401,   400,   402,   374,   377,   436,   437,     0,   441,     0,
       0,   333,   345,   335,   370,   372,   334,     0,     0,   399,
       0,   435,   166,   314,     0,     0,   324,     0,     0,     0,
       0,   310,     0,     0,     0,     0,   393,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   291,   292,     0,
     302,   336,   337,   305,   307,     0,     0,   295,   296,     0,
     234,   235,     0,   318,     0,   311,     2,    22,   311,     0,
       0,     0,     0,     0,     0,   317,   317,   317,   317,   317,
     317,   317,   317,   317,   317,   317,   317,   317,   317,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   317,   184,   184,   184,   193,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    70,    45,    54,   398,     0,
       0,     0,     0,   351,     0,     0,     0,     0,   436,   437,
       0,   403,   405,   407,   409,   411,   414,   419,   420,   424,
     427,   431,   437,   371,   373,   432,   433,   434,   378,   375,
     379,   376,   369,     0,   439,     0,     0,   165,     0,   384,
       0,     0,     0,   446,   447,   368,   315,   390,     0,   325,
     358,     0,     0,     0,     0,     0,     0,     0,   395,   309,
       0,     0,     0,     0,     0,     0,     0,     0,   290,   327,
     328,     0,     0,     0,     0,     0,   326,     0,     0,     0,
       0,     0,     0,     0,     4,    24,     8,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   208,     0,     0,     0,   169,   169,     0,   285,
       0,     0,     0,     0,   185,   176,     0,     0,   194,     0,
       0,     0,     0,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,     0,     0,     0,     0,     0,     0,    49,
       0,     0,    70,    47,    44,    51,    52,   396,     0,     0,
       0,     0,   353,   388,     0,     0,   438,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   419,
     443,   444,   445,   380,   442,     0,     0,   366,   316,     0,
       0,   343,     0,   341,   344,   362,   342,   365,     0,     0,
       0,     0,   390,     0,     0,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   360,
       0,   280,   151,     0,   152,   150,     0,     0,   142,     0,
       0,     0,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   283,     0,     0,
       0,     0,   177,   178,     0,     0,     0,     0,   284,     0,
     237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   400,     0,   276,   277,   399,     0,    70,    70,    41,
      41,     0,    50,    46,     0,   352,     0,     0,   354,     0,
       0,   406,     0,   408,   410,   412,   413,   415,   416,   417,
     418,   425,   426,   421,   422,   423,   429,   430,   428,   440,
     381,   367,     0,     0,   386,     0,     0,   312,   364,   141,
     338,   340,   339,     0,     0,     0,     0,     0,   201,   202,
       0,   157,     0,     0,     0,   394,     0,     0,     0,     0,
       0,   198,     0,     0,     0,   361,   359,   280,   280,     0,
       0,     0,     0,     0,   187,     0,   139,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,   170,
       0,     0,     0,     0,     0,     0,     0,     0,   179,     0,
       0,     0,   188,     0,     0,   238,     0,     0,     0,     0,
     257,     0,   257,     0,     0,     0,     0,     0,     0,     0,
      56,    39,    38,     0,    70,    70,    67,    69,     0,   397,
     136,     0,     0,   387,   391,     0,     0,     0,     0,     0,
       0,     0,   154,   153,   200,     0,     0,     0,     0,     0,
       0,   347,     0,     0,   199,   382,   281,   282,   286,     0,
       0,   350,   186,     0,     0,     0,     0,     0,     0,     0,
       0,   128,   129,     0,     0,     0,     0,     0,     0,     0,
     140,   130,     0,   132,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   288,   287,   147,
     329,   331,   330,   332,   146,   148,   390,     0,     0,     0,
     192,     0,     0,   257,     0,     0,   257,     0,     0,   258,
     259,     0,     0,   260,     0,     0,   241,     0,     0,     0,
       0,   257,     0,     0,     0,     0,     0,     0,    62,    57,
      42,    40,    43,     0,    71,     0,   346,   355,   404,   385,
       0,   389,   363,     0,     0,   156,     0,     0,     0,     0,
       0,     0,   349,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   125,     0,     0,   143,   144,   145,   131,   133,
       0,   135,     0,   206,   207,     0,     0,     0,     0,     0,
       0,   289,     0,     0,     0,   189,   190,     0,     0,   222,
     273,   274,   229,   223,   224,   275,   225,   255,   230,     0,
     226,   255,     0,   227,     0,     0,     0,   268,   267,   270,
     269,     0,     0,     0,   278,   279,    61,    58,    59,    60,
       0,    70,    66,    65,    68,     0,     0,   155,   158,   173,
       0,     0,     0,   348,     0,     0,     0,     0,     0,     0,
       0,   137,   126,     0,   134,     0,     0,     0,     0,   160,
       0,     0,     0,   356,     0,     0,   138,     0,     0,   247,
       0,   244,     0,     0,     0,     0,   265,     0,     0,     0,
     261,     0,   263,     0,   232,     0,    37,   383,   392,   172,
       0,   197,     0,   293,   294,     0,     0,     0,     0,   127,
     204,   205,     0,   161,     0,     0,     0,   181,   356,   195,
     252,   256,     0,     0,     0,     0,   252,     0,   228,   231,
       0,     0,   271,     0,     0,    64,     0,   171,     0,     0,
       0,     0,     0,   159,   167,     0,     0,   357,   183,     0,
       0,     0,   248,   251,   245,   246,     0,     0,   266,     0,
     262,   264,     0,     0,     0,     0,   299,   300,     0,   356,
     253,   254,     0,     0,     0,     0,     0,     0,     0,   297,
     298,     0,   175,   239,   249,     0,     0,   272,    63,     0,
     168,     0,     0,     0,     0,   250,   240,     0,     0,     0,
     196,     0,   252,     0,     0,     0,     0,   243,   252,     0,
     242
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1004, -1004, -1004,   537,   -45,     3,   541, -1004, -1004,   233,
      14, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
     169, -1004, -1004, -1004,   624,   493, -1004, -1004, -1004, -1004,
   -1004,   -93, -1004,  -440, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004,   371, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,   181, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004,  -160,  -699,   -55,   -52, -1003, -1004,
    -784,  -973,  -144,  -708,  -576,  -847,  -789,  -923,  -691,   -62,
    -429,  -838,  -213, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004,   440, -1004, -1004, -1004,   127,   -44, -1004,   220,   421,
    -263,    86, -1004,   -22,  -534, -1004, -1004, -1004,   -35, -1004,
   -1004, -1004,   439, -1004,  1193,  -841, -1004,  -995, -1004,  -188,
   -1004,  -317, -1004,   467, -1004,     8,   649,   651, -1004,  -342,
    -310,   495,    55,  -179,  -206, -1004,  -180, -1004,  -221,  1936,
     359,   365,   610,  1278,    56,   354,   356,   355,   357,     5,
    -333, -1004,  -473,  -475,   -54,  -592,  -451,   635
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    61,     3,     4,    62,    63,    64,   387,
     152,    65,    66,     9,    67,    68,    69,    70,    71,    72,
     754,    73,    74,    75,   295,   452,    76,    77,   868,   869,
     961,   757,   758,   453,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   662,   102,
     103,   104,   105,   106,   107,   108,   575,   109,   110,   111,
     112,   583,   729,   113,   114,   115,   116,   425,   117,   118,
     840,   119,   120,   429,   121,   122,   123,   124,   125,   570,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   232,   591,   856,   857,   860,   999,  1000,
     854,  1071,   997,   852,   853,   946,   947,   948,   843,   847,
     844,  1001,   679,   139,   140,   141,   142,   143,   144,   145,
     146,   202,   147,   194,   499,   234,   179,   197,   348,   374,
     368,   829,   830,   831,   220,   649,   501,   502,   181,   760,
     209,   212,   532,   375,   603,   303,   462,  1037,   349,   369,
     370,   832,   505,   833,   182,   183,   184,   185,   186,   529,
     339,   340,   187,   342,   346,   305,   507,   361,   205,   160,
     299,   188,   189,   950,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   190,   191,   493,   494
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   192,   631,   632,   219,   489,   633,   634,   635,   686,
     378,    11,   613,   221,   602,   350,   235,   951,   952,  1003,
     390,   391,   392,   393,   357,   954,   749,   376,   953,   528,
     154,   504,   497,   157,   858,   640,   956,   617,   957,  1072,
     166,   851,   159,  1068,  1055,     5,   845,   846,   333,   170,
     171,   172,   307,   861,   862,   213,   222,   168,   169,   677,
     150,   932,   166,   151,   236,   198,   199,   238,   170,   171,
     172,     1,   165,  1076,   307,   420,   334,   675,   945,   168,
     169,   159,   678,   473,   474,   161,   162,   163,   164,   510,
    1104,     6,   463,   166,  1102,   482,   483,   166,   954,   464,
     484,   170,   171,   172,     7,   307,   165,   166,   475,   476,
     168,   169,   321,   325,   326,   327,   166,   343,   467,   167,
    1092,   958,   344,   468,   168,   169,    10,  1094,   307,   170,
     171,   172,   298,   168,   169,   170,   171,   172,   858,    12,
     627,   628,   629,   630,   929,   565,   511,   149,   618,  1124,
     159,   308,   309,   177,   178,  1129,   954,   487,   337,  1040,
     936,   954,   944,   938,  1046,   855,   940,   751,   752,   547,
     548,   549,   550,   308,   309,   177,   178,   641,   355,   765,
     450,   874,   527,   875,   451,   651,   467,   341,   676,   366,
     328,   329,   373,   530,   674,   376,  1122,   527,   530,   153,
    1077,   954,   537,  1128,   308,   309,   177,   178,   308,   309,
     177,   178,   473,   644,   230,   231,   173,   174,   175,   176,
     177,   178,   330,   331,   166,   173,   174,   175,   322,   177,
     178,   477,   478,   155,   335,   791,   307,   475,   476,   645,
     321,   168,   169,   321,   479,   480,   481,  1105,  1106,   170,
     171,   172,   954,   325,   343,   455,   490,   491,   492,   344,
     894,   895,   527,   148,   898,   899,  1117,   654,   371,   855,
     954,   433,   434,  1115,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   170,   321,   172,   855,   321,   694,   695,
     697,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   771,   219,   892,   925,   645,  1006,   645,
     848,   628,  1007,   503,   871,   872,   156,  -436,   726,   328,
     329,  1008,  -436,   437,   438,  1009,   690,   691,   692,   693,
    1121,   513,   514,   530,  1125,   308,   309,   177,   178,  1010,
     166,   235,   158,  1011,  1012,   998,   696,   698,  1013,   998,
     471,   472,   307,   534,   441,   442,   538,   168,   169,   170,
     301,   172,   977,   978,   979,   980,   289,   290,   291,   292,
     293,   962,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   330,   331,   332,   544,
     193,   321,   321,   321,   321,   642,   643,   321,   196,   579,
     423,   350,   477,   478,   210,   930,   931,   371,  1044,  1045,
     321,   321,   201,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   636,   637,
     638,   848,   577,  1069,  1070,   161,   162,   163,   164,   170,
     601,   172,   321,  1025,  1026,   588,   849,   746,   747,   748,
     850,   308,   309,   177,   178,   321,   426,   427,   219,   746,
     747,   748,   203,   371,   786,   787,   204,   650,   206,   796,
     797,   500,   207,   321,   208,   211,   625,   626,   217,   218,
     223,   224,   225,   321,   227,   170,   171,   172,   656,   657,
     802,   226,   804,   228,   660,   663,   229,   233,   294,   219,
     297,   338,   341,   672,   358,   360,   362,   382,   221,   363,
     652,   409,   412,   410,   411,  1004,  1005,   413,   414,   685,
     835,  1016,   415,   416,   300,   417,   424,   428,   432,   435,
     306,   443,   444,   436,   439,   440,   445,   451,   446,   457,
     963,   447,   448,   466,   336,   712,   713,   965,   530,   458,
     966,   222,   321,   459,   461,   465,   722,   470,   485,   347,
     351,   469,   496,   321,   509,   522,   498,   525,   527,  1074,
    1075,   519,   531,   542,   364,  1048,  1049,   367,   372,   545,
     377,   347,   876,   546,   336,   580,   582,   569,   574,   321,
     321,   321,   566,   572,   381,  1091,  1090,   587,   902,   321,
     321,   606,   584,   589,   590,   585,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   611,   450,   298,   615,   639,   321,   321,   645,   647,
     653,   654,   669,   665,   772,   773,   371,   680,   681,   385,
     775,   776,   777,   688,   689,   714,   780,   711,   719,   728,
     753,   723,   735,   756,   759,   763,   724,   764,   733,   766,
     643,   771,   781,   793,   783,   785,   788,   837,   867,   794,
     795,   863,   800,   801,   817,   803,   864,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   873,
     859,   826,   865,   866,   870,   877,   823,   827,   828,   879,
     880,   881,   882,   883,   921,   935,   892,   937,   838,   839,
     939,   321,   941,   508,   942,   960,  1015,   512,  1014,   973,
    1017,   516,   517,  1018,  1042,  1041,   520,   521,  1043,  1073,
    1047,  1052,  1078,  1079,  1080,  1081,  1092,  1082,  1098,   533,
     536,  1093,  1095,  1103,   539,   540,   541,  1107,   372,  1097,
     219,   219,  1108,   884,   219,   219,  1111,  1113,   889,   221,
     221,   891,  1112,   221,   221,  1114,  1116,  1119,  1123,  1127,
     304,   893,  1126,   372,  1130,   386,   384,   687,   900,   755,
     296,   901,   964,   903,   904,   905,   906,   907,   576,   454,
     908,   933,   909,   910,   911,   934,   219,  1002,   943,   518,
     917,   725,   222,   222,   543,   221,   222,   222,   604,   321,
     321,   321,   834,   321,   535,   506,   323,   614,   324,   321,
     304,   878,   622,   621,   623,   345,   321,   624,     0,   321,
     486,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,     0,
       0,     0,   219,   219,   219,   219,     0,     0,     0,     0,
       0,   221,   221,   221,   221,   648,     0,   971,     0,     0,
       0,   974,     0,     0,     0,     0,     0,     0,   981,     0,
       0,   982,   983,   664,     0,   667,   668,     0,   984,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     992,     0,     0,     0,   222,   222,   222,   222,     0,     0,
       0,     0,   304,     0,     0,     0,   372,   512,   512,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,     0,     0,   219,   219,     0,   716,     0,   718,     0,
       0,     0,   221,   221,     0,     0,   727,     0,     0,  1020,
       0,   732,  1022,   321,   321,     0,     0,   321,     0,   321,
       0,  1029,     0,     0,     0,   304,     0,     0,     0,     0,
       0,     0,     0,     0,   304,   304,     0,   304,     0,     0,
       0,   761,     0,     0,     0,   222,   222,     0,     0,     0,
     321,   321,     0,   321,     0,     0,     0,     0,     0,     0,
    1058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   321,   321,     0,     0,     0,
       0,     0,     0,     0,     0,   321,     0,     0,   321,     0,
       0,     0,     0,     0,     0,     0,  1083,     0,     0,     0,
     321,   321,     0,     0,   161,   162,   163,   164,     0,     0,
       0,     0,     0,   605,     0,     0,     0,     0,     0,   321,
       0,   347,     0,   347,     0,   321,   166,     0,     0,   321,
     304,     0,     0,     0,     0,     0,  1109,     0,   167,     0,
     500,     0,   822,   168,   169,   824,   825,     0,     0,     0,
     508,   836,  1118,     0,   170,   171,   172,     0,     0,   842,
       0,   604,   604,   604,   604,   161,   162,   163,   164,   604,
     604,     0,     0,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,   304,   304,     0,   165,   166,     0,     0,
     605,     0,     0,   304,   304,   166,   304,     0,     0,   167,
       0,   500,     0,     0,   168,   169,     0,   167,     0,   304,
     304,     0,   168,   169,     0,   170,   171,   172,     0,     0,
       0,     0,     0,   170,   171,   172,     0,     0,     0,   347,
       0,     0,     0,     0,     0,   173,   174,   175,   176,   177,
     178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   923,   924,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   604,     0,     0,   604,
       0,     0,   604,     0,     0,   604,     0,     0,   949,   949,
     949,     0,     0,     0,     0,     0,   173,   174,   175,   176,
     177,   178,     0,     0,   173,   174,   175,   176,   177,   178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,   162,   163,   164,     0,     0,     0,
     304,     0,     0,     0,     0,     0,   304,   304,     0,     0,
     304,     0,     0,   304,   165,   166,     0,     0,     0,   994,
       0,     0,     0,   304,     0,     0,     0,   167,     0,     0,
       0,     0,   168,   169,     0,     0,     0,   949,     0,   604,
     604,     0,     0,   170,   171,   172,     0,     0,     0,     0,
       0,     0,   304,   304,     0,   304,   304,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   304,     0,     0,   605,   605,   605,   605,
       0,     0,     0,   302,   605,   605,     0,  1036,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   604,
     604,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1056,     0,     0,     0,     0,     0,   304,   304,   304,   304,
       0,     0,   304,     0,   173,   174,   661,   176,   177,   178,
       0,  1066,     0,   365,     0,     0,     0,     0,     0,     0,
       0,     0,   949,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   304,   304,
     304,   304,     0,   304,   304,   304,     0,     0,     0,     0,
       0,     0,     0,     0,   310,     0,     0,     0,     0,     0,
     605,   304,   304,     0,     0,     0,     0,     0,     0,   949,
     949,   605,     0,     0,   605,     0,     0,   605,     0,     0,
     605,     0,     0,     0,     0,     0,   955,     0,   949,     0,
       0,     0,     0,     0,   949,     0,     0,     0,     0,     0,
       0,   949,     0,     0,   304,   460,   304,   304,   304,     0,
     304,     0,     0,     0,   304,   304,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   304,     0,     0,   304,   304,   304,   304,   304,
     304,     0,     0,   304,     0,     0,     0,   304,   304,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   515,   955,
       0,     0,     0,     0,   605,   605,     0,   523,   524,     0,
     526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   449,     0,     0,   456,     0,     0,     0,     0,
     304,     0,   304,     0,     0,   304,   304,     0,     0,   304,
     304,     0,     0,     0,     0,   304,   304,   304,   304,     0,
     304,   304,     0,     0,   304,   304,     0,   955,     0,     0,
       0,     0,   955,     0,   605,   605,   488,     0,     0,   495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     304,     0,     0,     0,     0,   304,   304,   304,   304,     0,
       0,     0,   304,     0,   304,   304,     0,   304,     0,     0,
       0,     0,   955,   616,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   304,
     304,   304,   304,     0,     0,   304,   304,     0,   304,     0,
     239,   240,   241,   242,   243,   244,     0,     0,     0,     0,
       0,   245,     0,     0,   304,   304,     0,     0,   304,     0,
       0,     0,     0,   955,     0,     0,   658,   659,     0,     0,
       0,   304,   304,   666,     0,     0,   670,   671,     0,   673,
       0,   955,     0,   607,   608,   609,   610,     0,   304,   612,
       0,     0,   683,   684,     0,     0,     0,     0,     0,     0,
       0,     0,   619,   620,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,     0,     0,   260,   261,
     262,   263,     0,     0,   646,   264,   265,   266,     0,     0,
       0,   267,   268,     0,     0,     0,     0,   655,   269,   270,
     271,   272,     0,     0,     0,     0,   273,     0,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,     0,     0,
     277,   278,     0,     0,     0,   682,   279,     0,     0,     0,
       0,     0,     0,     0,   280,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   281,
     282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
       0,     0,     0,   774,     0,     0,     0,     0,     0,   778,
     779,     0,     0,   782,     0,     0,   784,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   792,     0,     0,     0,
       0,     0,     0,     0,   750,     0,     0,     0,   161,   162,
     163,   164,     0,     0,     0,   762,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   818,   819,     0,   820,   821,
     166,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   767,   167,   768,     0,     0,   841,   168,   169,     0,
       0,   769,   770,     0,     0,     0,     0,     0,   170,   601,
     172,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   789,   790,
       0,     0,     0,   195,     0,   200,     0,     0,     0,   885,
     886,   887,   888,     0,     0,   890,     0,     0,   214,   215,
     216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,     0,   918,   919,   920,   173,
     174,   175,   176,   177,   178,     0,     0,     0,     0,     0,
       0,     0,     0,   926,   927,   928,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   967,     0,   968,
     969,   970,     0,   972,     0,     0,     0,   975,   976,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   985,     0,     0,   986,   987,
     988,   989,   990,   991,     0,     0,   993,     0,     0,     0,
     995,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   352,   353,   354,     0,     0,   356,     0,
       0,   359,     0,     0,     0,   959,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   379,   380,  1019,     0,  1021,     0,     0,  1023,  1024,
     383,     0,  1027,  1028,     0,   388,   389,     0,  1030,  1031,
    1032,  1033,     0,  1034,  1035,     0,     0,  1038,  1039,     0,
       0,     0,     0,     0,     0,   408,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   418,   419,   421,   422,     0,
       0,     0,     0,  1057,   430,   431,     0,     0,  1059,  1060,
    1061,  1062,     0,     0,     0,  1063,     0,  1064,  1065,     0,
    1067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1084,  1085,  1086,  1087,     0,     0,  1088,  1089,
      -9,  1067,     0,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,     0,     0,     0,     0,  1099,  1100,     0,
       0,  1101,     0,     0,     0,  1050,  1051,     0,     0,  1053,
       0,  1054,     0,     0,  1110,  1067,     0,     0,     0,     0,
       0,    21,     0,     0,    22,    23,     0,     0,     0,     0,
       0,  1120,     0,     0,     0,     0,     0,     0,    24,     0,
      25,    -9,     0,     0,     0,     0,     0,     0,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,    26,   567,   568,     0,   571,
       6,   573,     0,     0,     0,     0,   578,  1096,     0,   581,
      27,     0,     0,     0,     0,   586,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
       0,    30,    31,    32,     0,     0,     0,    33,    34,    35,
       0,     0,    36,    37,    38,    39,    40,     0,     0,     0,
       0,    41,    42,    43,    44,     0,    45,    46,    47,    48,
      49,    50,    51,    52,     0,     0,     0,    53,    54,     0,
       0,    55,    56,    57,    58,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,    60,   237,     0,
       0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,    -8,    -8,     0,
       0,    -8,    -8,     0,     0,     0,   715,     0,   717,     0,
       0,   720,   721,     0,     0,    -8,     0,    -8,    -8,     0,
     730,   731,     0,     0,     0,   734,     0,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,     0,     0,     0,
       0,     0,    -8,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,     0,     0,     0,     0,     0,   798,   799,
      -8,     0,     0,    13,    14,    15,    16,    17,    18,    19,
      20,     0,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    21,
       0,     0,    22,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,     0,    25,   385,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,     0,   896,   897,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
      31,    32,     0,   912,     0,    33,    34,    35,     0,     0,
      36,    37,    38,    39,    40,     0,     0,     0,     0,    41,
      42,    43,    44,   922,    45,    46,    47,    48,    49,    50,
      51,    52,     0,     0,     0,    53,    54,     0,     0,    55,
      56,    57,    58,    13,    14,    15,    16,    17,    18,    19,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    59,    60,     0,     0,     0,    21,
       0,     0,    22,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,     0,    25,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
      31,    32,     0,     0,     0,    33,    34,    35,     0,     0,
      36,    37,    38,    39,    40,     0,     0,     0,     0,    41,
      42,    43,    44,     0,    45,    46,    47,    48,    49,    50,
      51,    52,     0,     0,     0,    53,    54,     0,     0,    55,
      56,    57,    58,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    59,    60
};

static const yytype_int16 yycheck[] =
{
      22,    23,   477,   478,    48,   338,   479,   480,   481,   543,
     216,     8,   452,    48,   443,   195,    61,   864,   865,   942,
     241,   242,   243,   244,   203,   866,   602,   215,   866,   371,
      16,   348,   342,    19,   742,   486,     1,    58,     3,  1042,
      58,   740,    58,  1038,     1,     0,   737,   738,    58,    86,
      87,    88,    70,   744,   745,    41,    48,    75,    76,    63,
      86,   845,    58,    89,    61,    42,    43,    64,    86,    87,
      88,    90,    57,  1046,    70,    91,    86,   528,   862,    75,
      76,    58,    86,    53,    54,    36,    37,    38,    39,   352,
    1093,    90,    56,    58,  1089,    66,    67,    58,   939,    63,
      71,    86,    87,    88,    13,    70,    57,    58,    78,    79,
      75,    76,   166,   167,   168,   169,    58,    46,    72,    70,
      56,    86,    51,    77,    75,    76,   169,    63,    70,    86,
      87,    88,   169,    75,    76,    86,    87,    88,   846,    62,
     473,   474,   475,   476,   843,   408,   352,    86,   169,  1122,
      58,   169,   170,   171,   172,  1128,   997,   336,   180,   997,
     851,  1002,   861,   854,  1002,   741,   857,   607,   608,   390,
     391,   392,   393,   169,   170,   171,   172,   487,   200,    65,
      16,    61,    53,    63,    20,   502,    72,    58,   530,   211,
      48,    49,   214,   372,   527,   383,  1119,    53,   377,    89,
    1047,  1042,    58,  1126,   169,   170,   171,   172,   169,   170,
     171,   172,    53,    54,   186,   187,   167,   168,   169,   170,
     171,   172,    48,    49,    58,   167,   168,   169,   170,   171,
     172,    69,    70,    86,   179,    59,    70,    78,    79,    63,
     294,    75,    76,   297,    82,    83,    84,  1094,  1095,    86,
      87,    88,  1093,   307,    46,    89,    48,    49,    50,    51,
     794,   795,    53,   169,   798,   799,  1113,    58,   213,   845,
    1111,   186,   187,  1111,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    86,   338,    88,   862,   341,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,    59,   348,    59,   840,    63,    59,    63,
     739,   644,    63,   348,   754,   755,    86,    46,   581,    48,
      49,    58,    51,   186,   187,    62,   547,   548,   549,   550,
    1119,   353,   354,   512,  1123,   169,   170,   171,   172,    59,
      58,   386,    86,    63,    59,   937,   552,   553,    63,   941,
      80,    81,    70,   375,   186,   187,   378,    75,    76,    86,
      87,    88,   896,   897,   898,   899,    21,    22,    23,    24,
      25,    89,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,    48,    49,    50,   386,
      76,   445,   446,   447,   448,    63,    64,   451,    52,   421,
     273,   581,    69,    70,    39,   176,   177,   352,    69,    70,
     464,   465,    94,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   860,   418,    69,    70,    36,    37,    38,    39,    86,
      87,    88,   496,   977,   978,   431,   179,   180,   181,   182,
     183,   169,   170,   171,   172,   509,   275,   276,   502,   180,
     181,   182,    93,   408,   677,   678,    62,   502,    95,   690,
     691,    72,    95,   527,    58,    58,   471,   472,    89,   169,
      99,    99,    95,   537,    86,    86,    87,    88,   510,   511,
     696,    95,   698,    86,   516,   517,    95,    35,    17,   543,
      68,    53,    58,   525,   169,    58,    96,   184,   543,   169,
     502,    62,     4,    95,    95,   944,   945,    95,    62,   541,
     726,   961,    95,     4,   159,     4,    28,    92,    62,   186,
     165,   187,    47,   186,   186,   186,    18,    20,    18,    59,
     873,    18,    18,    59,   179,   567,   568,   880,   727,    63,
     883,   543,   606,    62,    62,    58,   578,    74,    86,   194,
     195,    73,    53,   617,    58,    63,   166,    63,    53,  1044,
    1045,   169,    58,   185,   209,  1004,  1005,   212,   213,   170,
     215,   216,   761,   170,   219,    86,    26,    62,    62,   643,
     644,   645,   169,   169,   229,  1070,  1069,   169,   804,   653,
     654,    18,    95,   169,   174,    95,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,    60,    16,   169,   169,    59,   680,   681,    63,    59,
      55,    58,   169,    59,   656,   657,   581,    58,    58,    61,
     662,   663,   664,   169,   169,   169,   668,    62,   169,    27,
      19,   169,   174,    86,    59,    56,   169,    59,   169,   169,
      64,    59,    59,   685,    63,    54,    59,    95,    15,   169,
     169,    58,   694,   695,   169,   697,    58,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,    68,
     179,   169,    58,    55,    86,    59,   718,   169,   169,    54,
      63,    59,    56,    53,   169,   178,    59,    55,   730,   731,
      55,   765,    55,   348,    55,    14,    53,   352,    56,    59,
      54,   356,   357,    54,    63,    71,   361,   362,    56,   175,
      63,   169,    59,    63,    59,    59,    56,    63,    98,   374,
     375,    63,    63,   175,   379,   380,   381,    59,   383,  1082,
     794,   795,    54,   775,   798,   799,    63,    63,   780,   794,
     795,   783,    56,   798,   799,    97,   175,    63,    63,    56,
     160,   793,    63,   408,    56,   238,   235,   544,   800,   610,
     156,   803,   875,   805,   806,   807,   808,   809,   417,   296,
     812,   846,   814,   815,   816,   847,   840,   941,   860,   359,
     822,   581,   794,   795,   383,   840,   798,   799,   443,   863,
     864,   865,   726,   867,   375,   348,   167,   458,   167,   873,
     210,   765,   468,   467,   469,   190,   880,   470,    -1,   883,
     335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   840,    -1,
      -1,    -1,   896,   897,   898,   899,    -1,    -1,    -1,    -1,
      -1,   896,   897,   898,   899,   500,    -1,   889,    -1,    -1,
      -1,   893,    -1,    -1,    -1,    -1,    -1,    -1,   900,    -1,
      -1,   903,   904,   518,    -1,   520,   521,    -1,   910,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     922,    -1,    -1,    -1,   896,   897,   898,   899,    -1,    -1,
      -1,    -1,   302,    -1,    -1,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,    -1,    -1,   977,   978,    -1,   571,    -1,   573,    -1,
      -1,    -1,   977,   978,    -1,    -1,   581,    -1,    -1,   971,
      -1,   586,   974,  1007,  1008,    -1,    -1,  1011,    -1,  1013,
      -1,   983,    -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   364,   365,    -1,   367,    -1,    -1,
      -1,   616,    -1,    -1,    -1,   977,   978,    -1,    -1,    -1,
    1044,  1045,    -1,  1047,    -1,    -1,    -1,    -1,    -1,    -1,
    1022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1069,  1070,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1079,    -1,    -1,  1082,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1058,    -1,    -1,    -1,
    1094,  1095,    -1,    -1,    36,    37,    38,    39,    -1,    -1,
      -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,  1113,
      -1,   696,    -1,   698,    -1,  1119,    58,    -1,    -1,  1123,
     460,    -1,    -1,    -1,    -1,    -1,  1098,    -1,    70,    -1,
      72,    -1,   717,    75,    76,   720,   721,    -1,    -1,    -1,
     725,   726,  1114,    -1,    86,    87,    88,    -1,    -1,   734,
      -1,   736,   737,   738,   739,    36,    37,    38,    39,   744,
     745,    -1,    -1,    36,    37,    38,    39,    -1,    -1,    -1,
      -1,    -1,    -1,   513,   514,    -1,    57,    58,    -1,    -1,
     520,    -1,    -1,   523,   524,    58,   526,    -1,    -1,    70,
      -1,    72,    -1,    -1,    75,    76,    -1,    70,    -1,   539,
     540,    -1,    75,    76,    -1,    86,    87,    88,    -1,    -1,
      -1,    -1,    -1,    86,    87,    88,    -1,    -1,    -1,   804,
      -1,    -1,    -1,    -1,    -1,   167,   168,   169,   170,   171,
     172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   838,   839,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   851,    -1,    -1,   854,
      -1,    -1,   857,    -1,    -1,   860,    -1,    -1,   863,   864,
     865,    -1,    -1,    -1,    -1,    -1,   167,   168,   169,   170,
     171,   172,    -1,    -1,   167,   168,   169,   170,   171,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    38,    39,    -1,    -1,    -1,
     660,    -1,    -1,    -1,    -1,    -1,   666,   667,    -1,    -1,
     670,    -1,    -1,   673,    57,    58,    -1,    -1,    -1,   924,
      -1,    -1,    -1,   683,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,   942,    -1,   944,
     945,    -1,    -1,    86,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,   712,   713,    -1,   715,   716,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   733,    -1,    -1,   736,   737,   738,   739,
      -1,    -1,    -1,   160,   744,   745,    -1,   992,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1004,
    1005,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1015,    -1,    -1,    -1,    -1,    -1,   776,   777,   778,   779,
      -1,    -1,   782,    -1,   167,   168,   169,   170,   171,   172,
      -1,  1036,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1047,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   818,   819,
     820,   821,    -1,   823,   824,   825,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,    -1,    -1,
     840,   841,   842,    -1,    -1,    -1,    -1,    -1,    -1,  1094,
    1095,   851,    -1,    -1,   854,    -1,    -1,   857,    -1,    -1,
     860,    -1,    -1,    -1,    -1,    -1,   866,    -1,  1113,    -1,
      -1,    -1,    -1,    -1,  1119,    -1,    -1,    -1,    -1,    -1,
      -1,  1126,    -1,    -1,   884,   302,   886,   887,   888,    -1,
     890,    -1,    -1,    -1,   894,   895,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   912,    -1,    -1,   915,   916,   917,   918,   919,
     920,    -1,    -1,   923,    -1,    -1,    -1,   927,   928,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,   939,
      -1,    -1,    -1,    -1,   944,   945,    -1,   364,   365,    -1,
     367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   294,    -1,    -1,   297,    -1,    -1,    -1,    -1,
     970,    -1,   972,    -1,    -1,   975,   976,    -1,    -1,   979,
     980,    -1,    -1,    -1,    -1,   985,   986,   987,   988,    -1,
     990,   991,    -1,    -1,   994,   995,    -1,   997,    -1,    -1,
      -1,    -1,  1002,    -1,  1004,  1005,   338,    -1,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1020,    -1,    -1,    -1,    -1,  1025,  1026,  1027,  1028,    -1,
      -1,    -1,  1032,    -1,  1034,  1035,    -1,  1037,    -1,    -1,
      -1,    -1,  1042,   460,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1059,
    1060,  1061,  1062,    -1,    -1,  1065,  1066,    -1,  1068,    -1,
      29,    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,  1084,  1085,    -1,    -1,  1088,    -1,
      -1,    -1,    -1,  1093,    -1,    -1,   513,   514,    -1,    -1,
      -1,  1101,  1102,   520,    -1,    -1,   523,   524,    -1,   526,
      -1,  1111,    -1,   445,   446,   447,   448,    -1,  1118,   451,
      -1,    -1,   539,   540,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   464,   465,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,    -1,    -1,   496,   124,   125,   126,    -1,    -1,
      -1,   130,   131,    -1,    -1,    -1,    -1,   509,   137,   138,
     139,   140,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   154,   155,   156,    -1,    -1,
     159,   160,    -1,    -1,    -1,   537,   165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,    -1,    -1,
      -1,    -1,    -1,   660,    -1,    -1,    -1,    -1,    -1,   666,
     667,    -1,    -1,   670,    -1,    -1,   673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   606,    -1,    -1,    -1,    36,    37,
      38,    39,    -1,    -1,    -1,   617,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   712,   713,    -1,   715,   716,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   643,    70,   645,    -1,    -1,   733,    75,    76,    -1,
      -1,   653,   654,    -1,    -1,    -1,    -1,    -1,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   680,   681,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,   776,
     777,   778,   779,    -1,    -1,   782,    -1,    -1,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   818,   819,   820,   821,    -1,   823,   824,   825,   167,
     168,   169,   170,   171,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   840,   841,   842,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   884,    -1,   886,
     887,   888,    -1,   890,    -1,    -1,    -1,   894,   895,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   912,    -1,    -1,   915,   916,
     917,   918,   919,   920,    -1,    -1,   923,    -1,    -1,    -1,
     927,   928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,   198,   199,    -1,    -1,   202,    -1,
      -1,   205,    -1,    -1,    -1,   867,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   225,   226,   970,    -1,   972,    -1,    -1,   975,   976,
     234,    -1,   979,   980,    -1,   239,   240,    -1,   985,   986,
     987,   988,    -1,   990,   991,    -1,    -1,   994,   995,    -1,
      -1,    -1,    -1,    -1,    -1,   259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   269,   270,   271,   272,    -1,
      -1,    -1,    -1,  1020,   278,   279,    -1,    -1,  1025,  1026,
    1027,  1028,    -1,    -1,    -1,  1032,    -1,  1034,  1035,    -1,
    1037,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1059,  1060,  1061,  1062,    -1,    -1,  1065,  1066,
       0,  1068,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,  1084,  1085,    -1,
      -1,  1088,    -1,    -1,    -1,  1007,  1008,    -1,    -1,  1011,
      -1,  1013,    -1,    -1,  1101,  1102,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,  1118,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,    85,   410,   411,    -1,   413,
      90,   415,    -1,    -1,    -1,    -1,   420,  1079,    -1,   423,
     100,    -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,    -1,
      -1,   121,   122,   123,    -1,    -1,    -1,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,   141,   142,   143,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,    -1,    -1,   157,   158,    -1,
      -1,   161,   162,   163,   164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,   197,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,   570,    -1,   572,    -1,
      -1,   575,   576,    -1,    -1,    58,    -1,    60,    61,    -1,
     584,   585,    -1,    -1,    -1,   589,    -1,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,    -1,    -1,    -1,    -1,   692,   693,
     173,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,   796,   797,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,   116,    -1,    -1,    -1,    -1,   121,
     122,   123,    -1,   817,    -1,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,   141,
     142,   143,   144,   837,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,    -1,    -1,   157,   158,    -1,    -1,   161,
     162,   163,   164,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,   197,    -1,    -1,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,   116,    -1,    -1,    -1,    -1,   121,
     122,   123,    -1,    -1,    -1,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,   141,
     142,   143,   144,    -1,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,    -1,    -1,   157,   158,    -1,    -1,   161,
     162,   163,   164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,   197
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    90,   199,   202,   203,     0,    90,    13,   200,   211,
     169,   203,    62,     5,     6,     7,     8,     9,    10,    11,
      12,    41,    44,    45,    58,    60,    85,   100,   115,   116,
     121,   122,   123,   127,   128,   129,   132,   133,   134,   135,
     136,   141,   142,   143,   144,   146,   147,   148,   149,   150,
     151,   152,   153,   157,   158,   161,   162,   163,   164,   196,
     197,   201,   204,   205,   206,   209,   210,   212,   213,   214,
     215,   216,   217,   219,   220,   221,   224,   225,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   257,   258,   259,   260,   261,   262,   263,   265,
     266,   267,   268,   271,   272,   273,   274,   276,   277,   279,
     280,   282,   283,   284,   285,   286,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   321,
     322,   323,   324,   325,   326,   327,   328,   330,   169,    86,
      86,    89,   208,    89,   208,    86,    86,   208,    86,    58,
     377,    36,    37,    38,    39,    57,    58,    70,    75,    76,
      86,    87,    88,   167,   168,   169,   170,   171,   172,   334,
     341,   346,   362,   363,   364,   365,   366,   370,   379,   380,
     392,   393,   341,    76,   331,   377,    52,   335,    42,    43,
     377,    94,   329,    93,    62,   376,    95,    95,    58,   348,
     379,    58,   349,   208,   377,   377,   377,    89,   169,   334,
     342,   346,   363,    99,    99,    95,    95,    86,    86,    95,
     186,   187,   301,    35,   333,   202,   203,     1,   203,    29,
      30,    31,    32,    33,    34,    40,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     117,   118,   119,   120,   124,   125,   126,   130,   131,   137,
     138,   139,   140,   145,   154,   155,   156,   159,   160,   165,
     173,   188,   189,   190,   191,   192,   193,   194,   195,    21,
      22,    23,    24,    25,    17,   222,   222,    68,   169,   378,
     379,    87,   352,   353,   380,   373,   379,    70,   169,   170,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   170,   364,   365,   392,   392,   392,    48,    49,
      48,    49,    50,    58,    86,   370,   379,   341,    53,   368,
     369,    58,   371,    46,    51,   395,   372,   379,   336,   356,
     374,   379,   377,   377,   377,   341,   377,   371,   169,   377,
      58,   375,    96,   169,   379,   352,   341,   379,   338,   357,
     358,   370,   379,   341,   337,   351,   357,   379,   372,   377,
     377,   379,   184,   377,   204,    61,   201,   207,   377,   377,
     376,   376,   376,   376,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   377,    62,
      95,    95,     4,    95,    62,    95,     4,     4,   377,   377,
      91,   377,   377,   333,    28,   275,   275,   275,    92,   281,
     377,   377,    62,   186,   187,   186,   186,   186,   187,   186,
     186,   186,   187,   187,    47,    18,    18,    18,    18,   381,
      16,    20,   223,   231,   223,    89,   381,    59,    63,    62,
     352,    62,   354,    56,    63,    58,    59,    72,    77,    73,
      74,    80,    81,    53,    54,    78,    79,    69,    70,    82,
      83,    84,    66,    67,    71,    86,   369,   371,   381,   388,
      48,    49,    50,   394,   395,   381,    53,   368,   166,   332,
      72,   344,   345,   346,   359,   360,   361,   374,   379,    58,
     338,   372,   379,   341,   341,   352,   379,   379,   329,   169,
     379,   379,    63,   352,   352,    63,   352,    53,   367,   367,
     371,    58,   350,   379,   341,   350,   379,    58,   341,   379,
     379,   379,   185,   337,   203,   170,   170,   376,   376,   376,
     376,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   377,   377,   338,   169,   377,   377,    62,
     287,   377,   169,   377,    62,   264,   264,   208,   377,   341,
      86,   377,    26,   269,    95,    95,   377,   169,   208,   169,
     174,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,    87,   318,   352,   379,   380,    18,   381,   381,   381,
     381,    60,   381,   231,   378,   169,   352,    58,   169,   381,
     381,   384,   383,   385,   386,   387,   387,   388,   388,   388,
     388,   391,   391,   390,   390,   390,   392,   392,   392,    59,
     394,   368,    63,    64,    54,    63,   381,    59,   379,   343,
     346,   359,   363,    55,    58,   381,   341,   341,   352,   352,
     341,   169,   256,   341,   379,    59,   352,   379,   379,   169,
     352,   352,   341,   352,   388,   394,   367,    63,    86,   320,
      58,    58,   381,   352,   352,   341,   342,   207,   169,   169,
     376,   376,   376,   376,   338,   338,   372,   338,   372,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,    62,   341,   341,   169,   377,   379,   377,   379,   169,
     377,   377,   341,   169,   169,   336,   338,   379,    27,   270,
     377,   377,   379,   169,   377,   174,   377,   377,   377,   377,
     377,   377,   377,   377,   377,   377,   180,   181,   182,   312,
     381,   231,   231,    19,   218,   218,    86,   229,   230,    59,
     347,   379,   381,    56,    59,    65,   169,   381,   381,   381,
     381,    59,   341,   341,   352,   341,   341,   341,   352,   352,
     341,    59,   352,    63,   352,    54,   320,   320,    59,   381,
     381,    59,   352,   341,   169,   169,   376,   376,   377,   377,
     341,   341,   372,   341,   372,   341,   341,   341,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   169,   352,   352,
     352,   352,   379,   341,   379,   379,   169,   169,   169,   339,
     340,   341,   359,   361,   339,   372,   379,    95,   341,   341,
     278,   352,   379,   316,   318,   316,   316,   317,   318,   179,
     183,   303,   311,   312,   308,   312,   303,   304,   311,   179,
     305,   316,   316,    58,    58,    58,    55,    15,   226,   227,
      86,   231,   231,    68,    61,    63,   371,    59,   382,    54,
      63,    59,    56,    53,   341,   352,   352,   352,   352,   341,
     352,   341,    59,   341,   342,   342,   377,   377,   342,   342,
     341,   341,   372,   341,   341,   341,   341,   341,   341,   341,
     341,   341,   377,   352,   352,   352,   352,   341,   352,   352,
     352,   169,   377,   379,   379,   342,   352,   352,   352,   303,
     176,   177,   308,   304,   305,   178,   316,    55,   316,    55,
     316,    55,    55,   317,   303,   308,   313,   314,   315,   379,
     381,   313,   313,   319,   353,   380,     1,     3,    86,   381,
      14,   228,    89,   388,   229,   388,   388,   352,   352,   352,
     352,   341,   352,    59,   341,   352,   352,   342,   342,   342,
     342,   341,   341,   341,   341,   352,   352,   352,   352,   352,
     352,   352,   341,   352,   379,   352,   352,   310,   393,   306,
     307,   319,   310,   315,   318,   318,    59,    63,    58,    62,
      59,    63,    59,    63,    56,    53,   231,    54,    54,   352,
     341,   352,   341,   352,   352,   342,   342,   352,   352,   341,
     352,   352,   352,   352,   352,   352,   379,   355,   352,   352,
     319,    71,    63,    56,    69,    70,   319,    63,   318,   318,
     381,   381,   169,   381,   381,     1,   379,   352,   341,   352,
     352,   352,   352,   352,   352,   352,   379,   352,   355,    69,
      70,   309,   306,   175,   391,   391,   309,   313,    59,    63,
      59,    59,    63,   341,   352,   352,   352,   352,   352,   352,
     390,   391,    56,    63,    63,    63,   381,   388,    98,   352,
     352,   352,   355,   175,   306,   313,   313,    59,    54,   341,
     352,    63,    56,    63,    97,   319,   175,   313,   341,    63,
     352,   314,   315,    63,   309,   314,    63,    56,   315,   309,
      56
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   198,   199,   200,   201,   201,   202,   202,   203,   203,
     204,   204,   204,   204,   204,   204,   204,   204,   204,   204,
     205,   205,   205,   206,   207,   208,   208,   209,   210,   211,
     212,   212,   212,   212,   212,   212,   213,   214,   215,   216,
     217,   218,   218,   219,   220,   220,   221,   221,   222,   222,
     223,   224,   224,   224,   224,   225,   226,   226,   227,   227,
     227,   227,   228,   228,   228,   229,   229,   229,   230,   230,
     231,   231,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   233,   234,   234,   234,   234,   235,   235,
     236,   237,   238,   239,   240,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   251,   251,   252,
     253,   253,   253,   254,   254,   255,   255,   256,   257,   258,
     259,   260,   261,   261,   261,   261,   261,   262,   263,   264,
     264,   265,   266,   266,   267,   268,   269,   269,   270,   270,
     271,   272,   273,   274,   275,   275,   276,   277,   278,   278,
     278,   279,   280,   281,   281,   282,   283,   284,   284,   284,
     285,   286,   286,   286,   286,   286,   286,   286,   287,   287,
     288,   288,   288,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   301,   302,   302,   302,   303,
     304,   304,   305,   305,   306,   306,   306,   307,   307,   307,
     307,   308,   309,   309,   309,   310,   310,   311,   311,   311,
     311,   312,   312,   312,   312,   312,   312,   313,   313,   314,
     315,   315,   315,   316,   316,   317,   318,   318,   319,   319,
     320,   320,   320,   321,   321,   321,   321,   321,   321,   321,
     321,   322,   323,   324,   324,   325,   326,   327,   327,   327,
     327,   328,   328,   328,   328,   328,   328,   328,   328,   329,
     329,   330,   330,   331,   331,   332,   332,   333,   333,   334,
     334,   334,   334,   335,   335,   336,   337,   338,   338,   339,
     339,   340,   340,   341,   341,   341,   342,   342,   343,   343,
     343,   344,   344,   345,   345,   346,   347,   348,   349,   350,
     351,   352,   352,   353,   354,   354,   355,   355,   356,   357,
     357,   358,   359,   359,   360,   361,   362,   362,   363,   363,
     363,   363,   363,   363,   364,   364,   364,   365,   365,   365,
     366,   366,   367,   368,   369,   369,   369,   370,   370,   371,
     372,   373,   374,   375,   375,   376,   377,   377,   378,   379,
     379,   380,   380,   381,   382,   382,   383,   383,   384,   384,
     385,   385,   386,   386,   386,   387,   387,   387,   387,   387,
     388,   389,   389,   389,   389,   390,   390,   390,   391,   391,
     391,   391,   392,   392,   392,   392,   393,   393,   393,   393,
     393,   393,   394,   394,   394,   394,   395,   395
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     5,     2,     1,     1,     1,     1,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     2,     9,     6,     6,
       7,     0,     2,     7,     4,     3,     5,     4,     0,     2,
       2,     4,     4,     2,     3,     2,     0,     1,     2,     2,
       2,     2,     0,     6,     3,     3,     3,     1,     3,     1,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     7,     8,     9,     6,     6,
       6,     7,     6,     7,     8,     7,     6,     8,     8,     5,
       6,     5,     4,     7,     7,     7,     6,     6,     6,     1,
       4,     4,     4,     6,     6,     8,     7,     1,     8,    10,
       8,     9,     1,     1,     1,     3,     2,    10,    13,     0,
       2,    10,     9,     8,     1,    12,     0,     1,     0,     1,
       1,     9,     1,    10,     0,     1,     6,     5,     0,     2,
       2,     1,     6,     0,     1,     9,    16,     9,     5,     6,
       6,     5,     5,     4,     9,     9,     7,     7,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     7,     7,     7,     7,     7,     7,     9,     7,
       7,     9,     8,     4,     1,     1,     0,     1,     2,     7,
       9,     1,    16,    14,     1,     3,     3,     1,     3,     5,
       7,     5,     0,     2,     2,     0,     2,     0,     1,     1,
       1,     4,     6,     4,     6,     4,     6,     1,     1,     1,
       1,     3,     6,     2,     2,     2,     1,     1,     1,     1,
       0,     2,     2,     4,     4,     3,     6,     6,     6,     7,
       3,     2,     2,     9,     9,     2,     2,    12,    12,    11,
      11,     1,     2,     1,     1,     2,     1,     2,     1,     0,
       1,     0,     5,     0,     1,     0,     1,     0,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     5,     7,     4,
       4,     1,     3,     2,     2,     4,     0,     2,     1,     3,
       2,     3,     1,     4,     2,     1,     3,     4,     2,     2,
       1,     2,     1,     2,     1,     2,     2,     1,     2,     2,
       3,     4,     3,     7,     1,     5,     3,     5,     3,     5,
       1,     4,     7,     0,     3,     2,     3,     5,     1,     1,
       1,     1,     1,     1,     5,     1,     3,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       3,     1,     2,     2,     2,     1,     1,     1,     3,     2,
       4,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 653 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3013 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 22: /* Scope: ScopeStart error  */
#line 682 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3021 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* ScopeStart: LBRACE  */
#line 686 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3030 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeEnd: RBRACE  */
#line 690 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3036 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 27: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 701 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3045 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 709 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 717 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3062 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 36: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 731 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3070 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 738 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3080 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 746 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3090 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 754 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3099 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 761 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3107 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* VNameEqOpt: %empty  */
#line 764 "CISA.y"
                    {(yyval.string) = "";}
#line 3113 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 764 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3119 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 768 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3128 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 776 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3136 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 781 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3147 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 793 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3156 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 800 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3167 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* InputOffset: %empty  */
#line 807 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3173 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: OFFSET_EQ IntExp  */
#line 807 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3179 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputSize: SIZE_EQ IntExp  */
#line 808 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3185 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 814 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3193 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 818 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3201 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 822 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3209 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 826 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3217 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 832 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3225 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* AlignAttrOpt: %empty  */
#line 837 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3231 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 839 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3239 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 59: /* Align: ALIGN_EQ IDENT  */
#line 843 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3249 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ IntExp  */
#line 849 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3261 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ error  */
#line 857 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3269 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* AliasAttrOpt: %empty  */
#line 864 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3278 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 869 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3287 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 874 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3295 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 880 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3303 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 884 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3311 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT  */
#line 888 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3319 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 894 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3327 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* AttrOpt: OneAttr  */
#line 899 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3335 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* GenAttrOpt: %empty  */
#line 905 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3343 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 909 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3351 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 123: /* Label: LABEL  */
#line 970 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3357 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 975 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3366 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 981 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3374 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 986 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 992 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 999 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3401 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 1005 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3410 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1012 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3419 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1019 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3428 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1026 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1033 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3449 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1045 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3458 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1052 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3467 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1061 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3478 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1071 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1077 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1084 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3504 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1090 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3513 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1099 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3525 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1109 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3534 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1116 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3543 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1123 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3552 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1131 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3562 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1140 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3572 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1147 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3582 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1154 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3590 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* BreakpointInstruction: BREAKPOINT_OP  */
#line 1160 "CISA.y"
    {
      pBuilder->CISA_create_breakpoint_instruction(CISAlineno);
    }
#line 3598 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1166 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3607 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1172 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1178 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1196 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3634 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1203 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3645 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1213 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3655 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1221 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3665 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1227 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3674 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1235 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3684 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1244 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3694 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1253 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3704 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1262 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3714 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* SynchronizationInstruction: BARRIER_OP  */
#line 1269 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3722 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1272 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3730 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1275 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3738 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1278 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3746 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1281 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3754 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1287 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3763 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1294 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3773 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* Atomic16Opt: %empty  */
#line 1301 "CISA.y"
             {(yyval.flag) = false;}
#line 3779 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* Atomic16Opt: DOT DEC_LIT  */
#line 1302 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3788 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1309 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3798 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1322 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3808 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1330 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3818 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Sample3DInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1342 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3831 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* CPSEnableOpt: %empty  */
#line 1354 "CISA.y"
                     {(yyval.cps) = false;}
#line 3837 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: CPS  */
#line 1354 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3843 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* NonUniformSamplerEnableOpt: %empty  */
#line 1356 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3849 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1356 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3855 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Load3DInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1364 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3868 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* Gather43DInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1380 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3881 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: %empty  */
#line 1390 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3887 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1390 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3893 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1394 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3903 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1402 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3913 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperands: %empty  */
#line 1410 "CISA.y"
    {
    }
#line 3920 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1413 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3928 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1417 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 3936 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1426 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3949 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteModeOpt: %empty  */
#line 1436 "CISA.y"
                       {(yyval.string) = 0;}
#line 3955 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1441 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3965 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1449 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3977 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1461 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3995 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1477 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4003 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1483 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4018 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1496 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4027 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1504 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4036 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1511 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4045 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1519 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1525 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1531 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4072 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1537 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4081 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1543 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4090 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* AtomicBitwidthOpt: %empty  */
#line 1549 "CISA.y"
             {(yyval.intval) = 32;}
#line 4096 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1550 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4105 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1605 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4130 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1637 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4155 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1667 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4178 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1695 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4203 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1721 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4228 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1749 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4251 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1778 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,         // address info
            (yyvsp[-3].lsc_data_operand).shape,        // data type
            (yyvsp[-2].lsc_addr_operand).surface,      // surface array base
            (yyvsp[-2].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,          // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],      // src0 addr
            (yyvsp[-1].RawVar),              // src1 data
            (yyvsp[0].RawVar),              // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4276 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1812 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,      // address type
            (yyvsp[0].lsc_typed_operand).addr.size,      // address size
            (yyvsp[-1].lsc_data_operand).shape,          // data
            (yyvsp[0].lsc_typed_operand).surface,        // surface
            (yyvsp[0].lsc_typed_operand).surfaceIndex,   // surface index
            (yyvsp[-1].lsc_data_operand).reg,            // dst
            (yyvsp[0].lsc_typed_operand).regs[0],        // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0],  // u offset
            (yyvsp[0].lsc_typed_operand).regs[1],        // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1],  // v offset
            (yyvsp[0].lsc_typed_operand).regs[2],        // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2],  // r offset
            (yyvsp[0].lsc_typed_operand).regs[3],        // src0_lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
    }
#line 4311 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1856 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data size
            (yyvsp[-1].lsc_typed_operand).surface,       // surface
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0_lod
            (yyvsp[0].lsc_data_operand).reg,           // stored data
            nullptr,          // src2
            CISAlineno);
    }
#line 4346 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets LscPayloadReg LscPayloadReg  */
#line 1901 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_typed_operand).addr.type, // address model
            (yyvsp[-2].lsc_typed_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_typed_operand).surface,  // surface
            (yyvsp[-2].lsc_typed_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_typed_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-2].lsc_typed_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-2].lsc_typed_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-2].lsc_typed_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4378 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscAddrModelStateful LBRACK LscPayloadNonNullReg RBRACK  */
#line 1937 "CISA.y"
   {
        LSC_CACHE_OPTS caching {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape {LSC_DATA_SIZE_32b,LSC_DATA_ORDER_TRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_16;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-7].pred_reg),              // predicate
            (yyvsp[-6].lsc_subOpcode),              // subop
            (yyvsp[-5].lsc_sfid),              // sfid
            caching,         // no caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[-3].lsc_addr_model).type,           // address type
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[-3].lsc_addr_model).surface,        // surface
            (yyvsp[-3].lsc_addr_model).surfaceIndex,   // SS_IDX
            (yyvsp[-4].RawVar),                // dst data
            (yyvsp[-1].RawVar),                // src0 coords (u, v, r, lod) SIMD1 are packed in
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            nullptr,           // no src1 data
            nullptr,           // no src2 data
            CISAlineno);
   }
#line 4411 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1974 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4419 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscCacheOpts: %empty  */
#line 1981 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4425 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1982 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4431 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1983 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1990 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface, (yyvsp[-6].lsc_addr_model).surfaceIndex, {(yyvsp[-3].RawVar)}, {(yyvsp[-6].lsc_addr_model).type, (int)(yyvsp[-4].intval), (int)(yyvsp[-2].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4445 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm32 RBRACK LSC_ADDR_SIZE_TK  */
#line 1999 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface, (yyvsp[-8].lsc_addr_model).surfaceIndex, {(yyvsp[-5].RawVar), (yyvsp[-2].lsc_addr_surface_ident)}, {(yyvsp[-8].lsc_addr_model).type, (int)(yyvsp[-6].intval), (int)(yyvsp[-4].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4453 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 2002 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4462 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2026 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-13].lsc_addr_surface_ident),(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4470 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2046 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0, 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4478 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg  */
#line 2051 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[0].RawVar), 0};
    }
#line 4486 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg PLUS IntExpMul  */
#line 2054 "CISA.y"
                                          {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)(yyvsp[0].intval)};
    }
#line 4494 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg MINUS IntExpMul  */
#line 2058 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)-(yyvsp[0].intval)};
    }
#line 4502 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand  */
#line 2062 "CISA.y"
                                    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[0].lsc_typed_addr_operand).offset, 0, 0}};
      }
#line 4510 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2067 "CISA.y"
      {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset, 0}};
      }
#line 4518 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2073 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset}};
    }
#line 4526 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscPayloadNonNullReg  */
#line 2080 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-6].lsc_typed_addr_operand).reg,(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].RawVar)}, {(yyvsp[-6].lsc_typed_addr_operand).offset, (yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset}};
    }
#line 4534 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscTypedAddrOperandWithOffsets: LscAddrModelStateful LBRACK LscTypedAddrWithOffsetOperandList RBRACK LSC_ADDR_SIZE_TK  */
#line 2086 "CISA.y"
    {
        (yyval.lsc_typed_operand) = {(yyvsp[-4].lsc_addr_model).surface, (yyvsp[-4].lsc_addr_model).surfaceIndex,
               {(yyvsp[-2].lsc_typed_addr_operand_list).regs[0], (yyvsp[-2].lsc_typed_addr_operand_list).regs[1], (yyvsp[-2].lsc_typed_addr_operand_list).regs[2],(yyvsp[-2].lsc_typed_addr_operand_list).regs[3]},
               {(yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[0], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[1], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[2]},
               {(yyvsp[-4].lsc_addr_model).type, 1, 0, (yyvsp[0].lsc_addr_size)}};
    }
#line 4545 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscAddrImmOffsetOpt: %empty  */
#line 2097 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2098 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4557 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscAddrImmOffsetOpt: MINUS IntExpMul  */
#line 2099 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4563 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscAddrImmScaleOpt: %empty  */
#line 2104 "CISA.y"
                     {(yyval.intval) = 1;}
#line 4569 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscAddrImmScaleOpt: IntExpPrim TIMES  */
#line 2105 "CISA.y"
                     {(yyval.intval) = (yyvsp[-1].intval);}
#line 4575 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscAddrModelOpt: %empty  */
#line 2108 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4581 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2109 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4587 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2110 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG, nullptr, 0};}
#line 4593 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2115 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4601 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2118 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS, (yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4609 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2121 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4617 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2124 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2127 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4633 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2130 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4641 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* LscVectorOpImm32: IntExp  */
#line 2139 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval), ISA_TYPE_UD, CISAlineno);
    }
#line 4649 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* LscVectorOpReg: Var  */
#line 2149 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4661 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2157 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4673 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2165 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4690 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2179 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4698 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2183 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4706 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2189 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4714 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* LscPayloadReg: Var  */
#line 2197 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4722 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscPayloadNonNullReg: VarNonNull  */
#line 2204 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4730 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* SwitchLabels: %empty  */
#line 2210 "CISA.y"
    {
    }
#line 4737 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* SwitchLabels: COMMA SwitchLabels  */
#line 2213 "CISA.y"
    {
    }
#line 4744 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* SwitchLabels: IDENT SwitchLabels  */
#line 2216 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4753 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2223 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4761 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2227 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4769 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2231 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4777 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2235 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4786 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2241 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4794 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2246 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, false,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4804 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* BranchInstruction: Predicate IFCALL UNIFORM ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2253 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, true,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4814 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2260 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4822 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* FILE: FILE_OP STRING_LIT  */
#line 2265 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4830 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* LOC: LOC_OP DEC_LIT  */
#line 2270 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4838 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2276 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4847 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2283 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4856 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2290 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4864 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2296 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4872 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2302 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4883 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2310 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4894 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2318 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4905 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2326 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4916 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2336 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4924 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2341 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4932 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* NullaryInstruction: YIELD_OP  */
#line 2346 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4940 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2351 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4948 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2356 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4956 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2361 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4964 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2366 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4972 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* NullaryInstruction: FENCE_SW_OP  */
#line 2371 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4980 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* OwordModifier: %empty  */
#line 2375 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4986 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* Predicate: %empty  */
#line 2382 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4994 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2387 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 5002 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* PredSign: %empty  */
#line 2391 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 5008 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* PredSign: BANG  */
#line 2391 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 5014 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* PredCtrlOpt: %empty  */
#line 2393 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 5020 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* SatModOpt: %empty  */
#line 2396 "CISA.y"
                  {(yyval.sat) = false;}
#line 5026 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* SatModOpt: SAT  */
#line 2396 "CISA.y"
                                      {(yyval.sat) = true;}
#line 5032 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* SrcModifier: SRCMOD_NEG  */
#line 2399 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 5038 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* SrcModifier: SRCMOD_ABS  */
#line 2400 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 5044 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* SrcModifier: SRCMOD_NEGABS  */
#line 2401 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 5050 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* SrcModifier: SRCMOD_NOT  */
#line 2402 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 5056 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* ConditionalModifier: %empty  */
#line 2404 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5062 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* VecDstOperand_A: DstAddrOperand  */
#line 2409 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5068 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* VecDstOperand_G: DstGeneralOperand  */
#line 2410 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5074 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2412 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5080 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2413 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5086 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2418 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5092 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2422 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5098 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2426 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5104 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2427 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5110 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2431 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5116 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2435 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5122 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2436 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5128 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2440 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5134 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2444 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5140 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2446 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5146 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2449 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5158 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2459 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5167 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2466 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5177 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2474 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5187 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2482 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5197 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2513 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5206 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2520 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5214 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2531 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5223 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2536 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5232 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* RawOperandArray: %empty  */
#line 2544 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5240 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2549 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5249 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2557 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5259 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2565 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5268 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* DstGeneralOperand: Var DstRegion  */
#line 2570 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5277 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2576 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5286 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* SrcAddrOfOperand: AddrOfVar  */
#line 2597 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5294 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2601 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5303 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* AddrOfVar: AMP Var  */
#line 2607 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5316 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2618 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5326 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2626 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5336 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2633 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5346 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2643 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5354 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2648 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5364 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcImmOperand: FloatLit  */
#line 2656 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5372 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* SrcImmOperand: MINUS FloatLit  */
#line 2659 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5380 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* SrcImmOperand: DoubleFloatLit  */
#line 2665 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5388 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2669 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5396 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* FloatLit: DEC_LIT FTYPE  */
#line 2676 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5407 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* FloatLit: HEX_LIT FTYPE  */
#line 2683 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5417 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2691 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5428 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2697 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5439 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2708 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5450 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2716 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5461 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2725 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5471 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2743 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2760 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5501 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2771 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5513 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2781 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5522 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 388: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2786 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5531 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2791 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5542 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* PredVar: Var  */
#line 2799 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5554 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2808 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5569 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2820 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5584 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* SIMDMode: %empty  */
#line 2834 "CISA.y"
           {(yyval.intval) = 0;}
#line 5590 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2837 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* ElemNum: DOT DEC_LIT  */
#line 2848 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5608 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2860 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5617 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2866 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5628 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* ExecSizeInt: DEC_LIT  */
#line 2874 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5639 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2888 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5645 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2891 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5651 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2894 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5657 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2897 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5663 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2900 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5669 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 413: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2901 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5675 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2904 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5681 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2905 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5687 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2906 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5693 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2907 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5699 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2930 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5705 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2931 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5711 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 423: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2932 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5717 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 425: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2935 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5723 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2936 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5729 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2939 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5735 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2940 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5745 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2945 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5755 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 432: /* IntExpUnr: MINUS IntExpUnr  */
#line 2952 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5761 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 433: /* IntExpUnr: TILDE IntExpUnr  */
#line 2953 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5767 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 434: /* IntExpUnr: BANG IntExpUnr  */
#line 2954 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5773 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 438: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2962 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5779 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 439: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2966 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5788 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2970 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5798 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 441: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2976 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5809 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5813 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.15313.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2994 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
